/* contacts-im-service.c generated by valac 0.42.2, the Vala compiler
 * generated from contacts-im-service.vala, do not modify */

/*
 * Copyright (C) 2011 Alexander Larsson <alexl@redhat.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <config.h>


#define CONTACTS_TYPE_IM_SERVICE (contacts_im_service_get_type ())
typedef struct _ContactsImService ContactsImService;

struct _ContactsImService {
	const gchar* service_name;
	const gchar* display_name;
};



GType contacts_im_service_get_type (void) G_GNUC_CONST;
ContactsImService* contacts_im_service_dup (const ContactsImService* self);
void contacts_im_service_free (ContactsImService* self);
gchar* contacts_im_service_get_display_name (const gchar* service_name);

static const ContactsImService CONTACTS_IM_SERVICE_data[25] = {{"aim", N_ ("AOL Instant Messenger")}, {"facebook", N_ ("Facebook")}, {"gadugadu", N_ ("Gadu-Gadu")}, {"google-talk", N_ ("Google Talk")}, {"groupwise", N_ ("Novell Groupwise")}, {"icq", N_ ("ICQ")}, {"irc", N_ ("IRC")}, {"jabber", N_ ("Jabber")}, {"lj-talk", N_ ("Livejournal")}, {"local-xmpp", N_ ("Local network")}, {"msn", N_ ("Windows Live Messenger")}, {"myspace", N_ ("MySpace")}, {"mxit", N_ ("MXit")}, {"napster", N_ ("Napster")}, {"ovi-chat", N_ ("Ovi Chat")}, {"qq", N_ ("Tencent QQ")}, {"sametime", N_ ("IBM Lotus Sametime")}, {"silc", N_ ("SILC")}, {"sip", N_ ("sip")}, {"skype", N_ ("Skype")}, {"tel", N_ ("Telephony")}, {"trepia", N_ ("Trepia")}, {"yahoo", N_ ("Yahoo! Messenger")}, {"yahoojp", N_ ("Yahoo! Messenger")}, {"zephyr", N_ ("Zephyr")}};

/**
   * Returns the display name for the given IM service in a nicely presented way.
   */
gchar*
contacts_im_service_get_display_name (const gchar* service_name)
{
	gchar* result = NULL;
	gchar* _tmp5_;
#line 62 "../src/contacts-im-service.vala"
	g_return_val_if_fail (service_name != NULL, NULL);
#line 58 "contacts-im-service.c"
	{
		ContactsImService* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
#line 63 "../src/contacts-im-service.vala"
		d_collection = CONTACTS_IM_SERVICE_data;
#line 63 "../src/contacts-im-service.vala"
		d_collection_length1 = G_N_ELEMENTS (CONTACTS_IM_SERVICE_data);
#line 63 "../src/contacts-im-service.vala"
		for (d_it = 0; d_it < G_N_ELEMENTS (CONTACTS_IM_SERVICE_data); d_it = d_it + 1) {
#line 70 "contacts-im-service.c"
			ContactsImService d = {0};
#line 63 "../src/contacts-im-service.vala"
			d = d_collection[d_it];
#line 74 "contacts-im-service.c"
			{
				ContactsImService _tmp0_;
				const gchar* _tmp1_;
#line 64 "../src/contacts-im-service.vala"
				_tmp0_ = d;
#line 64 "../src/contacts-im-service.vala"
				_tmp1_ = _tmp0_.service_name;
#line 64 "../src/contacts-im-service.vala"
				if (g_strcmp0 (_tmp1_, service_name) == 0) {
#line 84 "contacts-im-service.c"
					ContactsImService _tmp2_;
					const gchar* _tmp3_;
					gchar* _tmp4_;
#line 65 "../src/contacts-im-service.vala"
					_tmp2_ = d;
#line 65 "../src/contacts-im-service.vala"
					_tmp3_ = _tmp2_.display_name;
#line 65 "../src/contacts-im-service.vala"
					_tmp4_ = g_strdup (g_dgettext (GETTEXT_PACKAGE, _tmp3_));
#line 65 "../src/contacts-im-service.vala"
					result = _tmp4_;
#line 65 "../src/contacts-im-service.vala"
					return result;
#line 98 "contacts-im-service.c"
				}
			}
		}
	}
#line 67 "../src/contacts-im-service.vala"
	_tmp5_ = g_strdup (service_name);
#line 67 "../src/contacts-im-service.vala"
	result = _tmp5_;
#line 67 "../src/contacts-im-service.vala"
	return result;
#line 109 "contacts-im-service.c"
}


ContactsImService*
contacts_im_service_dup (const ContactsImService* self)
{
	ContactsImService* dup;
#line 26 "../src/contacts-im-service.vala"
	dup = g_new0 (ContactsImService, 1);
#line 26 "../src/contacts-im-service.vala"
	memcpy (dup, self, sizeof (ContactsImService));
#line 26 "../src/contacts-im-service.vala"
	return dup;
#line 123 "contacts-im-service.c"
}


void
contacts_im_service_free (ContactsImService* self)
{
#line 26 "../src/contacts-im-service.vala"
	g_free (self);
#line 132 "contacts-im-service.c"
}


GType
contacts_im_service_get_type (void)
{
	static volatile gsize contacts_im_service_type_id__volatile = 0;
	if (g_once_init_enter (&contacts_im_service_type_id__volatile)) {
		GType contacts_im_service_type_id;
		contacts_im_service_type_id = g_boxed_type_register_static ("ContactsImService", (GBoxedCopyFunc) contacts_im_service_dup, (GBoxedFreeFunc) contacts_im_service_free);
		g_once_init_leave (&contacts_im_service_type_id__volatile, contacts_im_service_type_id);
	}
	return contacts_im_service_type_id__volatile;
}



